#define NUMOPTIONS 6
#define DEFAULTOPTION (NUMOPTIONS-1)

extern long long cpucycles_ticks_ppc32_mftb_setup(void);
extern long long cpucycles_ticks_ppc32_mftb(void);
extern long long cpucycles_ticks_default_perfevent_setup(void);
extern long long cpucycles_ticks_default_perfevent(void);
extern long long cpucycles_ticks_default_mach_setup(void);
extern long long cpucycles_ticks_default_mach(void);
extern long long cpucycles_ticks_default_monotonic_setup(void);
extern long long cpucycles_ticks_default_monotonic(void);
extern long long cpucycles_ticks_default_gettimeofday_setup(void);
extern long long cpucycles_ticks_default_gettimeofday(void);
extern long long cpucycles_ticks_default_zero_setup(void);
extern long long cpucycles_ticks_default_zero(void);

static struct {
  const char *implementation;
  long long (*ticks_setup)(void);
  long long (*ticks)(void);
} options[NUMOPTIONS] = {
{ "ppc32-mftb", cpucycles_ticks_ppc32_mftb_setup, cpucycles_ticks_ppc32_mftb },
{ "default-perfevent", cpucycles_ticks_default_perfevent_setup, cpucycles_ticks_default_perfevent },
{ "default-mach", cpucycles_ticks_default_mach_setup, cpucycles_ticks_default_mach },
{ "default-monotonic", cpucycles_ticks_default_monotonic_setup, cpucycles_ticks_default_monotonic },
{ "default-gettimeofday", cpucycles_ticks_default_gettimeofday_setup, cpucycles_ticks_default_gettimeofday },
{ "default-zero", cpucycles_ticks_default_zero_setup, cpucycles_ticks_default_zero },
} ;
